/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.11.2.4 by edhill, Thu Oct 2 02:28:05 2003 UTC revision 1.13.2.2 by edhill, Mon Oct 20 18:53:33 2003 UTC
# Line 49  expand_pkg_groups() { Line 49  expand_pkg_groups() {
49          cat ./p1.tmp | awk '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp          cat ./p1.tmp | awk '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50          matched=0          matched=0
51          for i in $PACKAGES ; do          for i in $PACKAGES ; do
52              line=`grep $i ./p2.tmp`              line=`grep "^ *$i" ./p2.tmp`
53              RETVAL=$?              RETVAL=$?
54              if test "x$RETVAL" = x0 ; then              if test "x$RETVAL" = x0 ; then
55                  matched=1                  matched=1
# Line 72  find_possible_configs()  { Line 72  find_possible_configs()  {
72    
73      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
74      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/'`      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
76      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
77      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
78  #     if test "x$OFLIST" = x ; then  #     if test "x$OFLIST" = x ; then
# Line 239  usage()  { Line 239  usage()  {
239      echo "      -disable=NAME | --disable=NAME"      echo "      -disable=NAME | --disable=NAME"
240      echo "    -enable NAME | --enable NAME"      echo "    -enable NAME | --enable NAME"
241      echo "      -enable=NAME | --enable=NAME"      echo "      -enable=NAME | --enable=NAME"
242        echo "    -standarddirs NAME | --standarddirs NAME"
243        echo "      -standarddirs=NAME | --standarddirs=NAME"
244      echo "    -noopt NAME | --noopt NAME"      echo "    -noopt NAME | --noopt NAME"
245      echo "      -noopt=NAME | --noopt=NAME"      echo "      -noopt=NAME | --noopt=NAME"
246  #    echo "    -cpp NAME | --cpp NAME"  #    echo "    -cpp NAME | --cpp NAME"
# Line 313  MODS= Line 315  MODS=
315  TOOLSDIR=  TOOLSDIR=
316  SOURCEDIRS=  SOURCEDIRS=
317  INCLUDEDIRS=  INCLUDEDIRS=
318    STANDARDDIRS=
319    
320  PWD=`pwd`  PWD=`pwd`
321  MAKE=make  MAKE=make
# Line 323  MACHINE=`uname -a` Line 326  MACHINE=`uname -a`
326  EXECUTABLE=  EXECUTABLE=
327  EXEHOOK=  EXEHOOK=
328  EXEDIR=  EXEDIR=
329    PACKAGES_CONF=
330    IEEE=
331    if test "x$MITGCM_IEEE" != x ; then
332        IEEE=$MITGCM_IEEE
333    fi
334    
335    AUTODIFF_PKG_USED=f
336    AD_OPTFILE=
337    
338  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
339  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
340  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
341    
342  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
343  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
344  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
345  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
346  gm_s6="EXECUTABLE EXEHOOK EXEDIR"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
347    
348  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
349    gm_s7="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF DIFF_FLAGS AD_TAMC_FLAGS AD_TAF_FLAGS"
350    gm_s8="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
351    gm_s9=""
352    
353    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7 $gm_s8"
354    
355    
356  echo  echo
357  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
358  gm_local="./gm_local"  gm_local="genmake_local"
359    for i in . $MODS ; do
360        if test -r $i/$gm_local ; then
361            source $i/$gm_local
362            break
363        fi
364    done
365  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
366  if test -e $gm_local ; then  if test -e $gm_local ; then
367      echo "using $gm_local"      echo "using $gm_local"
# Line 361  fi Line 383  fi
383  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
384  #done  #done
385  #parse_options  #parse_options
   
386  ac_prev=  ac_prev=
387  for ac_option ; do  for ac_option ; do
388    
# Line 386  for ac_option ; do Line 407  for ac_option ; do
407          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
408              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
409                    
410            -adoptfile | --adoptfile | -ad | --ad)
411                ac_prev=AD_OPTFILE ;;
412            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
413                AD_OPTFILE=$ac_optarg ;;
414            
415          -pdepend | --pdepend)          -pdepend | --pdepend)
416              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
417          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 431  for ac_option ; do Line 457  for ac_option ; do
457          -enable=* | --enable=*)          -enable=* | --enable=*)
458              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
459                    
460            -standarddirs | --standarddirs)
461                ac_prev=STANDARDDIRS ;;
462            -standarddirs=* | --standarddirs=*)
463                STANDARDDIRS=$ac_optarg ;;
464    
465          -noopt | --noopt)          -noopt | --noopt)
466              ac_prev=NOOPT ;;              ac_prev=NOOPT ;;
467          -noopt=* | --noopt=*)          -noopt=* | --noopt=*)
# Line 447  for ac_option ; do Line 478  for ac_option ; do
478              FC=$ac_optarg ;;              FC=$ac_optarg ;;
479                    
480          -ieee | --ieee)          -ieee | --ieee)
481              IEEE=1 ;;              IEEE=true ;;
482          -noieee | --noieee)          -noieee | --noieee)
483              IEEE=0 ;;              IEEE= ;;
484                    
485          -mpi | --mpi)          -mpi | --mpi)
486              MPI=1 ;;              MPI=true ;;
487          -nompi | --nompi)          -nompi | --nompi)
488              MPI=0 ;;              MPI= ;;
489                    
490          -jam | --jam)          -jam | --jam)
491              JAM=1 ;;              JAM=1 ;;
# Line 478  for ac_option ; do Line 509  for ac_option ; do
509            
510  done  done
511    
512    if test -f ./.genmakerc ; then
513        echo
514        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
515        echo "  file.  This file format is no longer supported.  Please see:"
516        echo
517        echo "    http://mitgcm.org/devel_HOWTO/"
518        echo
519        echo "  for directions on how to setup and use the new \"genmake2\" input"
520        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
521        echo
522    fi
523    
524  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
525      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
526          ROOTDIR=".."          ROOTDIR=".."
# Line 524  if test "x$OPTFILE" != xNONE ; then Line 567  if test "x$OPTFILE" != xNONE ; then
567              exit 1              exit 1
568          fi          fi
569          if test "x$DUMPSTATE" != xf ; then          if test "x$DUMPSTATE" != xf ; then
570              cp -f $OPTFILE "gm_optfile"              cp -f $OPTFILE "genmake_optfile"
571          fi          fi
572      else      else
573          echo "Error: can't read OPTFILE=\"$OPTFILE\""          echo "Error: can't read OPTFILE=\"$OPTFILE\""
# Line 532  if test "x$OPTFILE" != xNONE ; then Line 575  if test "x$OPTFILE" != xNONE ; then
575      fi      fi
576  fi  fi
577    
578    echo "  getting AD_OPTFILE information:  "
579    if test "x${AD_OPTFILE}" = x ; then
580        if test "x$MITGCM_AD_OF" = x ; then
581            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
582        else
583            AD_OPTFILE=$MITGCM_AD_OF
584        fi
585    fi
586    if test "x${AD_OPTFILE}" != xNONE ; then
587        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
588            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
589            source "$AD_OPTFILE"
590            RETVAL=$?
591            if test "x$RETVAL" != x0 ; then
592                echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
593                echo "--please check that variable syntax is bash-compatible"
594                exit 1
595            fi
596            if test "x$DUMPSTATE" != xf ; then
597                cp -f $AD_OPTFILE "genmake_ad_optfile"
598            fi
599        else
600            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
601            exit 1
602        fi
603    fi
604    
605  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain
606  #  and abort!  #  and abort!
607  if test "x$FC" = x ; then  if test "x$FC" = x ; then
# Line 540  if test "x$FC" = x ; then Line 610  if test "x$FC" = x ; then
610  Error: no Fortran compiler: please specify using one of the following:  Error: no Fortran compiler: please specify using one of the following:
611    1) within the options file ("FC=...") as specified by "-of=OPTFILE"    1) within the options file ("FC=...") as specified by "-of=OPTFILE"
612    2) the "-fc=XXX" command-line option    2) the "-fc=XXX" command-line option
613    3) the "./gm_local" file    3) the "./genmake_local" file
614  EOF  EOF
615      exit 1      exit 1
616  fi  fi
# Line 550  fi Line 620  fi
620  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
621      CPP="cpp"      CPP="cpp"
622  fi  fi
623  echo "#define A a" | cpp > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
624  RETVAL=$?  RETVAL=$?
625  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
626      cat <<EOF 1>&2      cat <<EOF 1>&2
# Line 558  if test "x$RETVAL" != x0 ; then Line 628  if test "x$RETVAL" != x0 ; then
628  Error: C pre-processor "$CPP" failed the test case: please specify using:  Error: C pre-processor "$CPP" failed the test case: please specify using:
629    
630    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
631    2) the "./gm_local" file    2) the "./genmake_local" file
632    
633  EOF  EOF
634      exit 1      exit 1
# Line 807  for i in $PACKAGES ; do Line 877  for i in $PACKAGES ; do
877      if test -d $adr ; then      if test -d $adr ; then
878          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
879          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
880            if test "x$i" = xautodiff ; then
881                AUTODIFF_PKG_USED=t
882            fi
883      else      else
884          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
885          exit 1          exit 1
# Line 833  done Line 906  done
906  # echo  # echo
907    
908  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
909  PACKAGES_DOT_H=PACKAGES.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
910  cat <<EOF >$PACKAGES_DOT_H".tmp"  cat <<EOF >$PACKAGES_DOT_H".tmp"
911  C=== GENMAKE v2 ===  C=== GENMAKE v2 ===
912  C  The following defines have been set by GENMAKE, so please do not  C  The following defines have been set by GENMAKE, so please do not
# Line 841  C  edit anything below these comments. Line 914  C  edit anything below these comments.
914  C  add or remove packages by re-running genmake with different  C  add or remove packages by re-running genmake with different
915  C  "-enable" and/or "-disable" options.  C  "-enable" and/or "-disable" options.
916    
917    #ifndef PACKAGES_H
918    #define PACKAGES_H
919    
920  C  Packages disabled by genmake:  C  Packages disabled by genmake:
921  EOF  EOF
922  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 900  for i in $PACKAGES ; do Line 976  for i in $PACKAGES ; do
976  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
977    
978  done  done
979    cat <<EOF >>$PACKAGES_DOT_H".tmp"
980    
981    #endif /* PACKAGES_H */
982    EOF
983    
984  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
985      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
986  else  else
# Line 915  fi Line 996  fi
996    
997  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
998  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
999  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = x ; then
1000        STANDARDDIRS="eesupp model"
1001    fi
1002  for d in $STANDARDDIRS ; do  for d in $STANDARDDIRS ; do
1003      adr="$ROOTDIR/$d/src"      adr="$ROOTDIR/$d/src"
1004      if test ! -d $adr ; then      if test ! -d $adr ; then
# Line 959  for n in $names ; do Line 1042  for n in $names ; do
1042  done  done
1043    
1044    
1045    #  Here, we build the list of files to be "run through" the adjoint
1046    #  compiler.
1047    if test -f ./ad_files ; then
1048        rm -f ./ad_files
1049    fi
1050    echo "  Creating the list of files for the adjoint compiler."
1051    for i in $SOURCEDIRS . ; do
1052        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1053        for j in $list_files ; do
1054            cat $i/$j >> ad_files
1055        done
1056    done
1057    cat <<EOF > adjoint_sed
1058    
1059     sed 's/call adopen(/call adopen ( mythid,\
1060         \&           /g
1061         s/call adclose(/call adclose( mythid,\
1062         \&           /g
1063         s/call adread(/call adread ( mythid,\
1064         \&           /g
1065         s/call adwrite(/call adwrite( mythid,\
1066         \&           /g' < ad_code_ad.f
1067    
1068    EOF
1069    chmod +x adjoint_sed
1070    
1071    
1072  echo  echo
1073  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1074  echo "  setting INCLUDES"  echo "  setting INCLUDES"
# Line 1064  EXEDIR      = ${EXEDIR} Line 1174  EXEDIR      = ${EXEDIR}
1174  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1175  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1176    
1177    #eh3  new defines for the adjoint work
1178    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1179    
1180  EOF  EOF
1181    
1182  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1113  cat srclist.inc    >> $MAKEFILE Line 1226  cat srclist.inc    >> $MAKEFILE
1226  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc   >> $MAKEFILE
1227  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc >> $MAKEFILE
1228  cat hlist.inc      >> $MAKEFILE  cat hlist.inc      >> $MAKEFILE
1229    echo               >> $MAKEFILE
1230  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1231  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1232  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
# Line 1145  clean: Line 1259  clean:
1259  Clean:  Clean:
1260          @make clean          @make clean
1261          @make cleanlinks          @make cleanlinks
1262          -rm -f Makefile.bak gm_state gm_optfile make.log PACKAGES.h*          -rm -f Makefile.bak genmake_state genmake_optfile make.log
1263  CLEAN:  CLEAN:
1264          @make Clean          @make Clean
1265          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1176  cleanlinks: Line 1290  cleanlinks:
1290  .p.f:  .p.f:
1291          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1292    
1293    #=========================================
1294    #===  Automatic Differentiation Rules  ===
1295    
1296    TAMC           = ${TAMC}
1297    TAF            = ${TAF}
1298    
1299    EOF
1300    
1301    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1302    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1303    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1304    for i in $ad_vars ; do
1305        name=$i
1306        t1="t2=\$"`echo $i`
1307        eval $t1
1308        printf "%-20s = " $name >> $MAKEFILE
1309        echo $t2 >> $MAKEFILE
1310    done
1311    
1312    echo "  Add the source list for AD code generation"
1313    echo >> $MAKEFILE
1314    echo -n "AD_FILES = " >> $MAKEFILE
1315    AD_FILES=`cat ad_files`
1316    for i in $AD_FILES ; do
1317        echo    " \\" >> $MAKEFILE
1318        echo -n " $i" >> $MAKEFILE
1319    done
1320    echo >> $MAKEFILE
1321    
1322    cat >>$MAKEFILE <<EOF
1323    
1324    # AD_FILES_SMALLF = \$(AD_FILES:.F=.f)
1325    
1326    EXE_AD_TAMC    = ${EXECUTABLE}_ad_tamc
1327    \$(EXE_AD_TAMC): \$(OBJFILES)
1328    
1329    EXE_AD_TAF     = ${EXECUTABLE}
1330    ad_taf: \$(OBJFILES)
1331            cat \$(AD_FILES) >! ad_input_code.f
1332            \$(TAF) \$(AD_TAF_FLAGS) ad_input_code.f
1333            ./adjoint_sed >! ad_output_code.f
1334            @make ad_output_code.o
1335            \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_output_code.o \$(LIBS)
1336    
1337    EXE_FTL_TAMC   = ${EXECUTABLE}_ftl_tamc
1338    EXE_FTL_TAF    = ${EXECUTABLE}_ftl_taf
1339    
1340    EXE_SVD_TAF    = ${EXECUTABLE}_ftl_taf
1341    EXE_BOTH_TAF   = ${EXECUTABLE}_ftl_taf
1342    
1343    #=========================================
1344    
1345  EOF  EOF
1346    
1347  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1215  printf "\n===  Done  ===\n" Line 1381  printf "\n===  Done  ===\n"
1381    
1382  #  Write the "state" for future records  #  Write the "state" for future records
1383  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1384      echo -n "" > gm_state      echo -n "" > genmake_state
1385      for i in $gm_state ; do      for i in $gm_state ; do
1386          t1="t2=\$$i"          t1="t2=\$$i"
1387          eval $t1          eval $t1
1388          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
1389      done      done
1390  fi  fi

Legend:
Removed from v.1.11.2.4  
changed lines
  Added in v.1.13.2.2

  ViewVC Help
Powered by ViewVC 1.1.22